<!doctype html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'} ">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" type="text/css" href="assets/js/vendor/viewer/viewer.min.css">
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-row layui-col-space15">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item" placeholder="输入关键字">
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                        <button type="button" id="emptyProject" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-cloud-download"></i> 基础项目
                        </button>
                        <button type="button" id="staticAssets" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-cloud-download"></i> 静态资源
                        </button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                    <!-- 表头按钮组 -->
                    <script type="text/html" id="headerToolBar">
                        <div class="layui-btn-group">
                            <button type="button" class="layui-btn layui-btn-sm" lay-event="saveEvent">
                                <i class="fa fa-lg fa-plus"></i> 新增
                            </button>
                            <button type="button" class="layui-btn layui-btn-normal layui-btn-sm" lay-event="updateEvent">
                                <i class="fa fa-lg fa-edit"></i> 编辑
                            </button>
                            <button type="button" class="layui-btn layui-btn-danger layui-btn-sm" lay-event="removeEvent">
                                <i class="fa fa-lg fa-trash"></i> 删除
                            </button>
                        </div>
                    </script>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script src="assets/js/vendor/viewer/viewer.min.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var laydate = layui.laydate;
        var windowWidth = $(window).width();
        var windowHeight = $(window).height();
        var resizeTimeout = null;
        var tableUrl = top.restAjax.path('api/dynamicconfigtable/listpagetable', []);

        // 初始化表格
        function initTable() {
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: tableUrl,
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 90,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                toolbar: '#headerToolBar',
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {type:'checkbox', fixed: 'left'},
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field:'tableName', width:140, title: '表名', align:'center'},
                        {field:'tableType', width:120, title: '类型', align:'center'},
                        {field:'tableTemplate', width: 120, title: '模板', align:'center'},
                        {field:'tableExplain', width:250, title: '说明', align:'center'},
                        {field:'dynamicForm', width:100, title: '表单', align:'center',
                            templet: function(row) {
                                return '<button type="button" class="layui-btn layui-btn-normal layui-btn-xs" lay-event="dynamicForm"><i class="fa fa-wpforms"></i> 编辑</button>';
                            }
                        },
                        {field:'createTable', width:100, title: '数据表', align:'center',
                            templet: function(row) {
                                if(row.isCreate === 0) {
                                    return '<button type="button" class="layui-btn layui-btn-normal layui-btn-xs" lay-event="saveDynamicTable"><i class="fa fa-table"></i> 创建表</button>';
                                }
                                return '<button type="button" class="layui-btn layui-btn-xs" lay-event="updateDynamicTable"><i class="fa fa-table"></i> 更新表</button>';
                            }
                        },
                        {field:'staticTable', width:100, title: '静态化', align:'center',
                            templet: function(row) {
                                return '<button type="button" class="layui-btn layui-btn-normal layui-btn-xs" lay-event="staticDynamicTable"><i class="fa fa-table"></i> 静态化</button>';
                            }
                        },
                    ]
                ],
                page: true,
                parseData: function(data) {
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable() {
            table.reload('dataTable', {
                url: tableUrl,
                where: {
                    keywords: $('#keywords').val()
                },
                height: $win.height() - 90,
            });
        }
        // 删除
        function removeData(ids) {
            top.dialog.msg(top.dataMessage.delete, {
                time: 0,
                btn: [top.dataMessage.button.yes, top.dataMessage.button.no],
                shade: 0.3,
                yes: function (index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.delete(top.restAjax.path('api/dynamicconfigtable/removetable/{ids}', [ids]), {}, null, function (code, data) {
                        top.dialog.msg(top.dataMessage.deleteSuccess, {time: 1000}, function () {
                            reloadTable();
                        });
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg(top.dataMessage.deleting, {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                }
            });
        }
        initTable();
        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable();
        });
        $(document).on('click', '#emptyProject', function() {
            top.dialog.open({
                url: top.restAjax.path('route/dynamicconfigtable/getgeneratoremptyproject', []),
                title: '生成空项目',
                width: '400px',
                height: '400px'
            });
        });
        $(document).on('click', '#staticAssets', function() {
            top.window.open(top.restAjax.path('https://xkk8ao4xdm.feishu.cn/drive/folder/fldcnz6hMTBtitjKyomajMXdkB6', []))
        });
        // 事件 - 增删改
        table.on('toolbar(dataTable)', function(obj) {
            var layEvent = obj.event;
            var checkStatus = table.checkStatus('dataTable');
            var checkDatas = checkStatus.data;
            if(layEvent === 'saveEvent') {
                layer.open({
                    type: 2,
                    title: false,
                    closeBtn: 0,
                    area: ['100%', '100%'],
                    shadeClose: true,
                    anim: 2,
                    content: top.restAjax.path('route/dynamicconfigtable/save', []),
                    end: function() {
                        reloadTable();
                    }
                });
            } else if(layEvent === 'updateEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectEdit);
                } else if(checkDatas.length > 1) {
                    top.dialog.msg(top.dataMessage.table.selectOneEdit);
                } else {
                    layer.open({
                        type: 2,
                        title: false,
                        closeBtn: 0,
                        area: ['100%', '100%'],
                        shadeClose: true,
                        anim: 2,
                        content: top.restAjax.path('route/dynamicconfigtable/update/{id}', [checkDatas[0].id]),
                        end: function() {
                            reloadTable();
                        }
                    });
                }
            } else if(layEvent === 'removeEvent') {
                if(checkDatas.length === 0) {
                    top.dialog.msg(top.dataMessage.table.selectDelete);
                } else {
                    var ids = '';
                    for(var i = 0, item; item = checkDatas[i++];) {
                        if(i > 1) {
                            ids += '_';
                        }
                        ids += item.id;
                    }
                    removeData(ids);
                }
            }
        });
        table.on('tool(dataTable)', function(obj) {
            var layEvent = obj.event;
            var data = obj.data;
            if(layEvent === 'dynamicForm') {
                top.dialog.open({
                    url: top.restAjax.path('route/dynamicconfigtable/dynamicconfigform/list/{tableName}', [data.tableName]),
                    title: '表单列表【'+ data.tableName +'表】',
                    width: (windowWidth * 0.9) +'px',
                    height: (windowHeight * 0.9) +'px'
                });
            } else if(layEvent === 'saveDynamicTable') {
                top.dialog.confirm('确定建表吗？', function(index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.post(top.restAjax.path('api/dynamicconfigtable/savedynamictable/{id}', [data.id]), {}, null, function(code, data) {
                        top.dialog.msg('建表成功');
                        reloadTable();
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg('正在建表，请稍后...', {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                });
            } else if(layEvent === 'updateDynamicTable') {
                top.dialog.confirm('确定更新表吗？字段新增或者删除都会直接修改表结构，有数据的列也会直接删除！', function(index) {
                    top.dialog.close(index);
                    var layIndex;
                    top.restAjax.put(top.restAjax.path('api/dynamicconfigtable/updatedynamictable/{id}', [data.id]), {}, null, function(code, data) {
                        top.dialog.msg('更新成功');
                        reloadTable();
                    }, function (code, data) {
                        top.dialog.msg(data.msg);
                    }, function () {
                        layIndex = top.dialog.msg('正在更新，请稍后...', {icon: 16, time: 0, shade: 0.3});
                    }, function () {
                        top.dialog.close(layIndex);
                    });
                });
            } else if(layEvent === 'staticDynamicTable') {
                top.dialog.open({
                    url: top.restAjax.path('route/dynamicconfigtable/getgeneratorcode/{id}', [data.id]),
                    title: '静态化代码',
                    width: '400px',
                    height: '250px'
                });
            }
        });
    });
</script>
</body>
</html>